/*
** Copyright R-U-ON, 2006
** www.r-u-on.com
*/

#ifdef WIN32

#include <windows.h>
#include <stdio.h>
#include "service.h"
#include "common.h"

#pragma warning(disable:4996)

char *AgentName();
char *agentname();


char *ServiceId()
{
	static char buff[256];
	sprintf(buff, "ruon.%s", agentname());
	return buff;
}

char *ServiceTitle()
{
	static char buff[256];
	sprintf(buff, "R-U-ON %s", AgentName());
	return buff;
}

char *ServiceDescription()
{
	static char buff[256];
	sprintf(buff, "%s Agent from R-U-ON. \r\nGo to www.r-u-on.com for more information.", AgentName());
	return buff;
}

int IsServiceRunning(SC_HANDLE service)
{
	SERVICE_STATUS_PROCESS status;
	DWORD bytesneeded;
	if (QueryServiceStatusEx(service, SC_STATUS_PROCESS_INFO,(LPBYTE) &status, sizeof(status), &bytesneeded))
	{
		return status.dwCurrentState==SERVICE_RUNNING;
	}
	else
	{
		iao_logsysmsg("IsServiceRunning: QueryServiceStatusEx failed!");
		return 0;
	}
}


int MyStartService(SC_HANDLE service)
{
	char *args[]={"service"};
	if (!StartService(service, 1, (LPCSTR*)args))
	{
		iao_logsysmsg("MyStartService: Service failed to start.");
		return -1;
	}
	return 0;

	/*if (IsServiceRunning(service))
	{
		return 0;
	}
	else
	{
		iao_logmsg("MyStartService: Failed. Service not running.");
		return -1;
	}*/
}

int IsServiceInstalled()
{
	int ret = -1;
	SC_HANDLE sman = OpenSCManager(NULL, SERVICES_ACTIVE_DATABASE, GENERIC_READ);
	if (sman!=NULL)
	{
		SC_HANDLE service = OpenService(sman, ServiceId(), SERVICE_QUERY_STATUS|SERVICE_START);
		if (service!=NULL)
		{
			if (!IsServiceRunning(service))
			{
				if (ask("The Agent Service is installed but not running. Would you like to start it now?"))
				{
					if (MyStartService(service)==-1)
					{
						if (ask("The Agent failed to start. Would you like to see the log file?")) 
						{
							showlog();
						}
					}
					else
					{
						syncmsgbox("Agent Service executed");
					}
				}
			}
			else
			{
				syncmsgbox("Agent Service installed and running");
			}
			ret = 1;
			CloseServiceHandle(service);
		}
		else
		{
			ret = 0;
		}
		CloseServiceHandle(sman);
	}
	else
	{
		iao_logsysmsg("IsServiceInstalled: Can't open Service Database");
	}
	return ret;
}

int InstallService(char *path)
{
	int ret = -1;

	SC_HANDLE sman = OpenSCManager(NULL, SERVICES_ACTIVE_DATABASE, SC_MANAGER_CREATE_SERVICE);
	if (sman!=NULL)
	{
		SC_HANDLE service;
		char buff[1024];
		sprintf(buff, "%s service", path);
		service = CreateService(
			sman, ServiceId(), ServiceTitle(), GENERIC_EXECUTE|SERVICE_CHANGE_CONFIG|SERVICE_QUERY_STATUS, SERVICE_WIN32_OWN_PROCESS|SERVICE_INTERACTIVE_PROCESS,
			SERVICE_AUTO_START, SERVICE_ERROR_NORMAL, buff, NULL, NULL, NULL, NULL, "");
		if (service!=NULL)
		{
			SERVICE_DESCRIPTION desc;
			desc.lpDescription = ServiceDescription();
			ChangeServiceConfig2(service, SERVICE_CONFIG_DESCRIPTION, &desc);
			ret = MyStartService(service);
			if (ret==0)
			{
				iao_logmsg("InstallService: Agent Service installed.");
			}
			CloseServiceHandle(service);
		}
		else
		{
			iao_logsysmsg("InstallService: Error creating the Agent Service in the Service Database");
		}
	CloseServiceHandle(sman);
	}
	else
	{
		iao_logsysmsg("InstallService: Can't open Service Database");
	}
	return ret;
}


int UninstallService()
{
	int ret = -1;
	SC_HANDLE sman = OpenSCManager(NULL, SERVICES_ACTIVE_DATABASE, GENERIC_READ);
	if (sman!=NULL)
	{
		SC_HANDLE service = OpenService(sman, ServiceId(), DELETE|SERVICE_STOP);
		if (service!=NULL)
		{
			if (DeleteService(service))
			{
				SERVICE_STATUS status;
				ControlService(service, SERVICE_CONTROL_STOP, &status);
				ret = 0;
			}
			else
			{
				iao_logsysmsg("UninstallService: Service delete failed");
			}
			CloseServiceHandle(service);
		}
		else
		{
			iao_logsysmsg("UninstallService: Can't open service, assuming not there");
			ret = 0;
		}
		CloseServiceHandle(sman);
	}
	else
	{
		iao_logsysmsg("UninstallService: Can't open the Service database");
	}
	return ret;
}

int ServiceStop()
{
	int ret = -1;
	SC_HANDLE sman = OpenSCManager(NULL, SERVICES_ACTIVE_DATABASE, GENERIC_READ);
	if (sman!=NULL)
	{
		SC_HANDLE service = OpenService(sman, ServiceId(), SERVICE_STOP);
		if (service!=NULL)
		{
			SERVICE_STATUS status;
			if (ControlService(service, SERVICE_CONTROL_STOP, &status))
			{
				ret = 0;
			}
			else
			{
				iao_logsysmsg("ServiceStop: Sending stop signal failed");
			}
			CloseServiceHandle(service);
		}
		else
		{
			iao_logsysmsg("ServiceStop: Can't open service, assuming not there");
		}
		CloseServiceHandle(sman);
	}
	else
	{
		iao_logsysmsg("UninstallService: Can't open the Service database");
	}
	return ret;
}

int GoService()
{
	int ret = -1;
	SC_HANDLE sman = OpenSCManager(NULL, SERVICES_ACTIVE_DATABASE, GENERIC_READ);
	if (sman!=NULL)
	{
		SC_HANDLE service;
		service = OpenService(sman, ServiceId(), GENERIC_EXECUTE);
		if (service!=NULL)
		{
			ret = MyStartService(service);
			CloseServiceHandle(service);
		}
		else
		{
			iao_logsysmsg("GoService: Error openning the Agent Service in the Service Database");
		}
	CloseServiceHandle(sman);
	}
	else
	{
		iao_logsysmsg("GoService: Can't open Service Database");
	}
	return ret;

}


SERVICE_STATUS servicestatus; 
SERVICE_STATUS_HANDLE   servicestatusHandle;

VOID WINAPI MyServiceCtrlHandler (DWORD Opcode) 
{ 

	switch(Opcode) 
	{ 
	case SERVICE_CONTROL_STOP:
    case SERVICE_CONTROL_SHUTDOWN:
         servicestatus.dwCurrentState  = SERVICE_STOPPED;
         break;

	case SERVICE_CONTROL_PAUSE: 
	case SERVICE_CONTROL_INTERROGATE: 
	case SERVICE_CONTROL_CONTINUE: 
		/* Fall through to send current status. */
		break; 

	default: 
		iao_logmsg("MyServiceCtrlHandler: Unrecognized opcode"); 
	} 

	if (!SetServiceStatus (servicestatusHandle,  &servicestatus)) 
	{ 
		iao_logsysmsg("MyServiceCtrlHandler: SetServiceStatusFailed");
	} 
	return; 
}

int init(char *);

DWORD WINAPI init_tr(LPVOID lpParameter)
{
	int ret = init((char *)lpParameter);
	if (ret==-1)
	{
		if (ask("Agent failed. Would you like to see a log file?"))
		{
			showlog();
		}
	}
	exit(-1);
	return ret;
}



void WINAPI MyServiceStart (DWORD argc, LPTSTR *argv) 
{
	DWORD thread_id;

	servicestatusHandle = RegisterServiceCtrlHandler(ServiceId(), MyServiceCtrlHandler); 
	if (servicestatusHandle == NULL) 
	{ 
		iao_logsysmsg("RegisterServiceCtrlHandler failed");
		return;
	} 

	servicestatus.dwServiceType        = SERVICE_WIN32; 
	servicestatus.dwCurrentState       = SERVICE_RUNNING; 
	servicestatus.dwControlsAccepted   = SERVICE_ACCEPT_STOP; 
	servicestatus.dwWin32ExitCode      = 0; 
	servicestatus.dwServiceSpecificExitCode = 0; 
	servicestatus.dwCheckPoint         = 0; 
	servicestatus.dwWaitHint           = 0; 
	if (!SetServiceStatus(servicestatusHandle, &servicestatus)) 
	{ 
		iao_logmsg("iao_logsysmsg: failed setting service status");
		return;
	} 

	CloseHandle(CreateThread(NULL, 128000, init_tr, NULL, 0, &thread_id));
}

void ServiceMain()
{
	SERVICE_TABLE_ENTRY   DispatchTable[] = 
	{ 
		{ agentname(), MyServiceStart }, 
		{ NULL,              NULL } 
	}; 

	if (!StartServiceCtrlDispatcher(DispatchTable)) 
	{
		iao_logsysmsg("ServiceMain: start ctrl dispatcher failed");
	}
	exit(0);
}



#endif
